<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<%@ page import="java.util.*" %>
<%@ page import="java.text.SimpleDateFormat" %>
<%@ page import="com.xerox.docushare.*" %>
<%@ page import="com.xerox.docushare.object.*" %>
<%@ page import="com.xerox.docushare.routing.WizardBean" %>
<%@ page import="com.xerox.docushare.routing.StepData" %>
<%@ page import="com.xerox.docushare.amber.util.GenericUtil" %>
<%@ page import="com.xerox.docushare.amber.util.MessageDB" %>

<%@ page import="com.xerox.docushare.amber.util.AmberUtility" %>

<!--
<jsp:useBean id="dsrouting" scope="session" class="com.xerox.docushare.routing.DSRouting" />
 -->
<%
request.setCharacterEncoding(dsrouting.getCharEncoding());
response.setContentType(dsrouting.getContentType());
%>
<jsp:useBean id="wizardBean" scope="session" class="com.xerox.docushare.routing.WizardBean" />
<jsp:useBean id="browserInfo" scope="session" class="com.xerox.docushare.routing.BrowserInfo">
    <% browserInfo.setUserAgent(request.getHeader("USER-AGENT")); %>
</jsp:useBean>
<%
final DSSession dsSession = (DSSession)request.getAttribute("DSSession");
final java.util.Locale locale = dsSession.getLocale();
DSUser dsUser = (DSUser)dsSession.getLoginPrincipal();
boolean isCPXUser = DSUserLevels.CPX_LEVEL.equals(dsUser.getUserLevel());
String cssFile = isCPXUser?"routing_wizard_cpx.css":"routing_wizard.css";
if(wizardBean.getOwner().equals("owner")){
%>
	<script language="javascript">
	<!-- Hide code from non-js browsers
		alert("<%=MessageDB.get("routing_session_timed_out", locale)%>");
	//-->
	</script>
<%
	out.print("\n<script language=\"javascript\">parent.close();</script>");
	return;
}
if(dsUser.isGuestUser()){
    out.print("\n<script language=\"javascript\">parent.close();</script>");
    return;
}
boolean btnReadOnly = dsSession.isReadOnly();

int curStep = wizardBean.setCmd_fromPage(request);
int fromPage = wizardBean.getFromPage();
String keySuffix = dsrouting.getDateKeySuffix(request); //AR8506+
String Page = MessageDB.get("page", locale);

if(request.getParameter("cmd").equals("Submit"))
{
  out.print("\n<script language=\"javascript\">parent.close();</script>"); //AR7042+

  try{
    out.print("<img src=\""+wizardBean.getOwner()+".jpg\"><br>\n");
    out.print("<input type=\"button\" value=\"Refresh\" onClick=\"document.location.reload();\"> ");
    out.print(" &nbsp \n<input type=\"button\" value=\"Close\" onClick=\"parent.close();\"> ");
    out.print("</html>");
    return;
  }catch(Exception e) {
    out.print("wizardBean.getOwnerName(): "+e+ "<br>"); 
  }
}
%>
<TITLE><%=MessageDB.get("routing_wizard_title", new Object[]{"4", ""+curStep}, locale)%></TITLE>
  <%@ include file="ThemeUtil.jsp" %>
  
<%
// DocuShare Base CSS
%>
<link rel="stylesheet" href="<%=request.getContextPath()%>/themes/<%=theme_name%>/routing_wizard.css" type="text/css"></link>
<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare.gif) 0% 0% no-repeat;}</style>
<%
// Market-specific styling for XC
// ******************************
if (! ("FX".equals(dsSession.getServerProperty(DSSession.companyBrand)))) {

   // Enterprise Edition Licensed Site
   if (dsSession.getServer().isLicensed( DSLicenseCodes.ENTERPRISE_EDITION )) {
   %>   
   <style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_enterprise.gif) 0% 0% no-repeat;}</style>
   <%
   // Education Edition Licensed Site 
   } else if (dsSession.getServer().isLicensed( DSLicenseCodes.EDUCATION_EDITION )) {
   %>
   <style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_education.gif) 0% 0% no-repeat;}</style>
   <%
   }
// Market-specific styling for FX
// ******************************
} else {
   // Education Edition Licensed Site
   if (dsSession.getServer().isLicensed( DSLicenseCodes.EDUCATION_EDITION )) {
   %>   
   <style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_education.gif) 0% 0% no-repeat;}</style>
   <%
   // CPX logo shows up only for CPX users when NOT licensed for the Education Edition  
   } else if (dsSession.getLoginPrincipal().isUserLevel(DSUserLevels.CPX_LEVEL)) {
   %>
   <style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_cpx.gif) 0% 0% no-repeat;}</style>
   <%
   }

}
%>
  
</head>

<body id="wiz_review" onLoad="checkSubmit();">
    <div id="header">
        <h1>DocuShare</h1>
        <h2>Routing Slip Setup (Step 1 Review)</h2>
        <div id="header-wrapper"><p><strong><%=MessageDB.get("Username", locale)%>:</strong> <%= GenericUtil.getShortName(dsUser, dsSession) %></p></div>
        <ul id="subheader">
        <li class="nav_label"><%=MessageDB.get("routing_wizard_header", new Object[]{curStep, wizardBean.getSteps()},locale)%>:</li>
        <li class="wiz_page1"><%=Page%> 1 &raquo;</li>
        <li class="wiz_page2"><%=Page%> 2 &raquo;</li>
        <li class="wiz_page3"><%=Page%> 3 &raquo;</li>
        <li class="wiz_review"><%=MessageDB.get("routing_wizard_review", locale)%></li>
        </ul>
    </div>

    <div id="content">
<form method="POST" action="wizard_p4.jsp" onsubmit="disableSubmitButtons();">
<input type=hidden name="cmd">
<input type=hidden name="docs" value="<%=wizardBean.getDocumentsString()%>">

<script language="javascript">
<!-- Hide code from non-js browsers
var fm = self.document.forms[0];
//alert('docs = '+ fm.docs.value);

<%@include file="wizard_functions.js" %>

function inputSaveAsName()
{
  var props = 'dependent=yes,scrollBars=no,resizable=yes,toolbar=no,menubar=no,location=no,directories=no,width=430,height=250';
  inputTemplateWindow = window.open("input_template_name.jsp?owner=<%=wizardBean.getOwner()%>", "Input_Template_Name", props);
  inputTemplateWindow.onClose = window.focus();
  inputTemplateWindow.focus();
  return false; //do not submit, inputTemplateWindow will call fm.saveTemplate() to submit
}

function saveTemplate(saveAsName, asPrivate, wfID_overwrite)
{ fm.cmd.value = "Save_Template";
  fm.saveAs.value = saveAsName;
  fm.asPrivate.value = asPrivate;
  fm.wfID_overwrite.value = wfID_overwrite;
  fm.mainsubmit.disabled=true;
  fm.submit();
}

function removeDocument()
{
  var selIdx = fm.docList.selectedIndex;
  if(selIdx < 0){
    alert('<%=MessageDB.get("wzdp4_js_popup_sel_doc", locale)%>'); //SDL AR9147
    return;
  }
  if(fm.docList.length == 1){
    alert('<%=MessageDB.get("wzdp4_js_popup_at_least_one", locale)%>'); //SDL AR9147
    fm.docList.selectedIndex = -1;
    return;
  }
  var selVal = fm.docList.options[selIdx].value + "&";
  var sdocs = fm.docs.value + "&";
  var idx = sdocs.indexOf(selVal);
  sdocs = sdocs.substring(0, idx) + sdocs.substring(idx + selVal.length);
  fm.docs.value = sdocs.substring(0, sdocs.length-1);
  //alert("fm.docs.value = "+ fm.docs.value);
  fm.docList.remove(selIdx);
  
  //AR7444+ refresh ACL checking:
  fm.cmd.value='RemoveDocument';
  fm.submit();
}

//AR26361: Routing doesn't disable the submit button when user doesn't have sufficient permission and owner doesn't have manager rights
function checkSubmit()
{
  if(fm.disableCheck.value == "false")
  	fm.mainsubmit.disabled=false;
}

function disableSubmitButtons()
{	
	if(fm.cmd.value == "Submit")
		fm.mainsubmit.disabled=true;
}

<%
%>
//-->
</script>

<h2><%=MessageDB.get("routing_wzdp4_header", locale)%></h2>
<p><%=MessageDB.get("routing_wzdp4_slip_review", locale)%></p>
				
<h3><%=MessageDB.get("routing_wzdp4_step_details", locale)%></h3>
    <table class="propstable">
    <tr>
        <td valign="top"><b><%=MessageDB.get("routing_subject", locale)%>:</b> </td>
        <td colspan="2"><%= AmberUtility.xss_safe_value(wizardBean.getRoutingSubject()) %></td>
    </tr>

    <tr>
        <td valign="top"><b><%=MessageDB.get("comment_label", locale)%>:</b> </td>
        <td colspan="2"><%= AmberUtility.xss_safe_value(wizardBean.getRoutingBody()) %></td>
    </tr>

    <tr>
        <td valign="top"><b><%=MessageDB.get("routing_wzdp4_documents", locale)%>:</b> </td>
        <td><select name="docList" size="4" multiple="multiple" style="width:350px">
<%
try{
  Iterator itrDoc = wizardBean.getDocuments().iterator();
  while(itrDoc.hasNext()){
    String doc = (String)itrDoc.next();
    DSObject dsObj = dsSession.getObject(new DSHandle(doc), new DSSelectSet(DSObject.title)); //AR13400
    if (dsObj instanceof DSVersion)
      dsObj = ((DSVersion)dsObj).getDocument(DSSelectSet.NO_PROPERTIES);
    out.print("  <option value=\""+ doc +"\">"+ AmberUtility.xss_safe_value(((DSDocument)dsObj).getTitle())+"\n");
  }
}catch(Exception e) { out.print("Error to get document: "+ e+ "<br>"); }
%>
        </select> </td>

        <td valign="center" align="left"><input type="button" value="<%=MessageDB.get("button.remove", locale)%>"
            onclick="removeDocument()" /></td>
    </tr>
<%
boolean stepNoRecipient = false;
boolean lastStepMoveNext = false; //AR12808+
int n = 1;
int nStep = wizardBean.getSteps();
while(true){
  StepData stepData = wizardBean.getStep(n++);
  if(stepData == null) break;
  ArrayList stepRecipients = stepData.getRecipients();
  int step = stepData.getStep();
  if(stepRecipients == null || stepRecipients.size()==0)
    stepNoRecipient = true;
  else if (!wizardBean.checkActiveUser(stepRecipients))
  		stepNoRecipient = true;
  %>
  <tr>
  <td colspan=2>
  <b><u><%=MessageDB.get("routing_wzdp4_routing_step", locale)%> <%=step%> </u></b>
  </td>
  <td align="left">
  <input type=submit value="<%=MessageDB.get("button.edit", locale)%>" onClick="fm.cmd.value='Edit_<%=step%>'; fm.action='wizard_p1.jsp';"> 
  <%
  if (nStep > 1)
  {
  %>
  <input type=submit value="<%=MessageDB.get("button.remove", locale)%>" onClick="fm.cmd.value='Remove_<%=step%>';"> 
  <%
  }
  %>
  </td>
  </tr>
  <tr>
  <td VALIGN="top"><b><%=MessageDB.get("routing_wzdp4_recipients", locale)%></b>:</td>
  <td colspan=2>
  <% 
  Iterator itrHandle=stepRecipients.iterator();
  Iterator itr=stepData.getRecipientNames().iterator();
  while( itrHandle.hasNext() && itr.hasNext()){
 		 String dsHandleString = (String)itrHandle.next();
 		 String dsObjectName = (String)itr.next();
  	 if (wizardBean.checkActiveUser(dsHandleString))
     			out.print(dsObjectName+"<br>"); 
     else {
    		if (dsHandleString.startsWith("User-"))
    			out.print(dsObjectName+", <b><font color=\"#ff0000\">" + MessageDB.get("routing_inactive_user", locale)+ "</font></b> <br>");
    		else 
    			out.print(dsObjectName+", <b><font color=\"#ff0000\">" + MessageDB.get("routing_group_no_active_user", locale)+ "</font></b> <br>");
     }
  }
  %>
  </td></tr>
  <tr>
  <td><b><%=MessageDB.get("routing_wzdp4_action", locale)%></b>:</td>
  <td colspan=2>
  <%
  //SDL AR+: //format "ReviewOrderedNotShare, MajorityReply"
  String actionOrder = stepData.getActionOrder();
  try{
      String sAction=actionOrder, sReply="";
      int idx = actionOrder.indexOf(", ");
      if(idx != -1) {
          sReply = MessageDB.get(actionOrder.substring(idx + 2), locale);
          sAction = actionOrder.substring(0, idx);
      }
      actionOrder = MessageDB.get(sAction, locale);
      if(idx != -1) actionOrder += ", " + sReply;
  }catch(Exception es) {System.out.println("report_base SDL: "+ es); }
  //end SDL AR+
  %>
  <%= actionOrder %></td></tr>
  <tr>
  <td VALIGN="top"><b><%=MessageDB.get("routing_wzdp4_notification", locale)%></b>:</td>
  <td colspan=2>
  <%
    String tmp = (stepData.getNotifyOverdue()?MessageDB.get("routing_wzdp3_of_escalation", locale)+", ":"")
    + (stepData.getNotifyReply()?MessageDB.get("routing_wzdp3_of_progress", locale)+", ":"")
    + (stepData.getNotifyCompletion()?MessageDB.get("routing_wzdp3_when_complete", locale):"");
    if(tmp.endsWith(", ")) tmp = tmp.substring(0, tmp.length()-2);
  %>
   <%=tmp%>	
  </td></tr>
  <tr>
  <td><b><%=MessageDB.get("routing_wzdp4_escalation", locale)%></b>:</td>
  <td colspan=2>
  <%
  Date overdueDate = stepData.getOverdueDate();
  if(overdueDate!=null){
      String esact = stepData.getEscalationAction();
      if(n>wizardBean.getSteps() && StepData.ESCALATION_NEXT.equals(esact)) //AR12808+
        lastStepMoveNext = true;
      if(esact!=null && esact.trim().length()>0)
        esact = MessageDB.get("routing_wzdp3_action_"+esact.toLowerCase(), locale);
      else
        esact = MessageDB.get("routing_wzdp3_action_none", locale);
      out.print(esact + " " + MessageDB.get("routing_wzdp3_if", locale) + " ");
      if(stepData.getByDays() != null)
        out.print(MessageDB.get("routing_wzdp3_step_days", new Object[] {stepData.getByDays().intValue(),step}, locale)); //AR14065
      else
        out.print((new SimpleDateFormat(MessageDB.get("date_short_4"+keySuffix, locale))).format(overdueDate)); //AR8506
        
      if(stepData.getByDatePast() != null) {//AR19777+
        out.print(" <font color=\"red\"><strong>(" + MessageDB.get("routing_wzdp4_past_due_date", locale) + ")</strong></font> ");
      }
  }%>
  </td></tr>
  <tr><td> &nbsp </td></tr>
  <%  
}%>
</table>

<h3><%=MessageDB.get("routing_wzdp4_confirm_acl", locale)%></h3>
        
    <input type="hidden" name="fromPage" value="4" /> 
    <input type="hidden" name="saveAs" value="" />
    <input type="hidden" name="asPrivate" value="true" /> 				
    <input type="hidden" name="wfID_overwrite" value="0" /> 
 
<% //=================================================================================
String workflowUpdateACL = dsrouting.getWorkflowUpdateACL();
boolean allowSetVersionACL = dsrouting.getAllowSetVersionACL();

//dsrouting.setDSSession(request);
request.setCharacterEncoding("UTF8");
response.setContentType("text/html; charset=UTF-8");
final String ACL_OK = "<img src=\"images/green_check.gif\"/> " + MessageDB.get("routing_acl_ok", locale);
final String CONFIRM_ACL = "<img src=\"images/icon_warning2.png\"/> " + MessageDB.get("routing_confirm_acl", locale);
final String OWNER_CANNOT_ADD_ACL = "<img src=\"images/icon_error.png\"/> " + MessageDB.get("routing_owner_cannot_add_acl", locale);
final String RECORD_CANNOT_ADD_ACL = "<img src=\"images/icon_error.png\"/> " + MessageDB.get("routing_record_cannot_add_acl", locale); //AR9778+
final String NEVER_ADD_ACL = "<img src=\"images/icon_error.png\"/> " + MessageDB.get("routing_never_add_acl", locale);
final String ACL_ADD = MessageDB.get("routing_acl_add", locale);
final String ACL_REQUIRE = MessageDB.get("routing_require", locale); //AR9778+
final String ACL_READOBJ = MessageDB.get("routing_acl_readobj", locale);
final String ACL_READLINK = MessageDB.get("routing_acl_readlink", locale);
final String ACL_WRITEOBJ = MessageDB.get("routing_acl_writeobj", locale);
final String ACL_WRITELINK = MessageDB.get("routing_acl_writelink", locale);
final String ACL_READ = MessageDB.get("routing_acl_read", locale);
final String ACL_WRITE = MessageDB.get("routing_acl_write", locale);

String docRecipients = ""; //doc: u1, u2
boolean canSubmit = true;

DSAcl[] dsAcls = wizardBean.checkACL();
boolean canOwnerManageAllDoc = wizardBean.getCanOwnerManageAllDoc();

if(dsAcls != null && dsAcls.length>0){
try{ 
  for(int i=0; i<dsAcls.length; i++){
  	DSAcl dsAcl = dsAcls[i];
  	DSDocument dsDoc = null;
    if(dsAcl instanceof DSDocument)
      dsDoc = ((DSDocument)dsAcl);
    else if(dsAcl instanceof DSVersion)
      dsDoc = ((DSVersion)dsAcl).getDocument(DSSelectSet.NO_PROPERTIES);

  	boolean isRecord = false;
  	try{ isRecord = dsDoc.getIsRecord();
  	}catch(Exception er) {System.out.println("##wizard_p4 dsDoc.getIsRecord(): "+er); }
  	
  	String line = "<A HREF=\"" + request.getContextPath() + "/dsweb/Services/" 
  	+ ((DSObject)dsAcl).getHandle() + "/Permissions\" target=_blank>" + AmberUtility.xss_safe_value(dsDoc.getTitle())
  	+ "</a>: "+ (isRecord?RECORD_CANNOT_ADD_ACL:"") +"<br>";
  	
  	//loop each recipient:
  	DSAclEntry[] aclEntry = wizardBean.getAdditionalACL( ((DSObject)dsAcl).getHandle() );
  	for(int j=0; j<aclEntry.length; j++){
  	  try{
  	  DSHandle dsHandle = aclEntry[j].principal;
  	  int permissions   = aclEntry[j].permissions;
      	String rw = (isRecord?ACL_REQUIRE:ACL_ADD) +" ";
        boolean threePermMode = ((Boolean)dsSession.getServerProperty(DSSession.threePermissionMode)).booleanValue();
        if(threePermMode) {//AR19632+ threePermMode
        	if((permissions & DSPermission.AllRead) > 0)
        	  rw += ACL_READ + ", ";
        	if((permissions & DSPermission.AllWrite) > 0)
        	  rw += ACL_WRITE + ", ";
        }//AR19632+ threePermMode
        else {//sixPermMode
        	if((permissions & DSPermission.ReadObject) > 0)
        	  rw += ACL_READOBJ + ", ";
        	if((permissions & DSPermission.ReadLinked) > 0)
        	  rw += ACL_READLINK + ", ";
        	if((permissions & DSPermission.WriteObject) > 0)
        	  rw += ACL_WRITEOBJ + ", ";
        	if((permissions & DSPermission.WriteLinked) > 0)
        	  rw += ACL_WRITELINK + ", ";
    	}//sixPermMode
    	  
    	if(rw.endsWith(", "))
    	  rw = rw.substring(0, rw.length()-2);    	
    	
    	DSPrincipal principal = (DSPrincipal)dsSession.getObject(dsHandle, new DSSelectSet(DSObject.title)); //AR13400
    	if(principal instanceof DSUser){
          line += GenericUtil.getLongName((DSUser)principal, dsSession);
      }else{//group
        line += principal.getTitle();
      }
      line += " ("+ rw +")<br>  "; //full name
      }catch(Exception ef){ System.out.println("##wizard_p4 line 297, "+dsAcl+" loop aclEntry: "+ ef); }
    }//for aclEntry
    
    if(line.indexOf(")<br> ") != -1)
      docRecipients += line.substring(0, line.length()-2) + "<br>";
            
  }//for(dsAcls)
  
  if(docRecipients.length()==0)
    canSubmit = true;
  else
    canSubmit = canOwnerManageAllDoc && !workflowUpdateACL.equalsIgnoreCase("never");
  
}catch(Exception e) 
{ System.out.println("##wizard_p4 check acl: "+e); }
}//if dsACL != null
%>
<%=docRecipients.length()==0?ACL_OK:(!canOwnerManageAllDoc?OWNER_CANNOT_ADD_ACL:(workflowUpdateACL.equalsIgnoreCase("never")?NEVER_ADD_ACL:CONFIRM_ACL)) %>
<br>
<%
if(docRecipients.length()>0)
  out.print(docRecipients);
else
  out.print("<br>");
%>
				
<div id="buttonbar">
<p class="note"><%=MessageDB.get("routing_wzdp4_click_buttons", locale)%></p>
<input type="submit" value="&laquo; <%=MessageDB.get("button.back", locale)%>" onClick="fm.cmd.value='Back';
 <%=((wizardBean.getActionOrder(curStep)+"").startsWith("Information")?"fm.action='wizard_p2.jsp';":"fm.action='wizard_p3.jsp';")%>">
<input type="submit" name="mainsubmit" value="<%=MessageDB.get("button.submit", locale)%>" 
<%
boolean disableCheck = false;
StepData stepData = wizardBean.getStep(1);
if(btnReadOnly || stepData == null)
  disableCheck = true;
else{
  //ArrayList recs = stepRecipients;
  //if(recs == null || recs.size()==0)
  //AR14516 undo AR12808 fix: if(stepNoRecipient || lastStepMoveNext) //AR12808+
  if(stepNoRecipient)
    disableCheck = true;
  else if(!canSubmit)
    disableCheck = true;
    
if(disableCheck)
	out.print(" disabled ");
}
%>
 onClick="fm.saveassubmit.disabled=true;fm.cmd.value='Submit';">
<input type="hidden" name="disableCheck" value="<%=disableCheck%>">
<input type="button" value="<%=MessageDB.get("button.cancel", locale)%>" onClick="parent.close();">
<input type="submit" value="+ <%=MessageDB.get("button.add_step", locale)%>" <%=btnReadOnly?"disabled":""%> onClick="fm.cmd.value='Add_Step'; fm.action='wizard_p1.jsp';">
<input type=button name="saveassubmit" value="<%=MessageDB.get("button.save_slip", locale)%>" <%=btnReadOnly?"disabled":""%> onClick="inputSaveAsName();">
			
</div>
</form>			
</div>    
</body>
</html>
