<html>
<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE" />
<%@ page import="com.xerox.docushare.*" %>
<%@ page import="com.xerox.docushare.object.*" %>
<%@ page import="com.xerox.docushare.amber.api.*" %>
</head>
<body>
<jsp:useBean id="dsrouting" scope="session" class="com.xerox.docushare.routing.DSRouting" />
<%
request.setCharacterEncoding(dsrouting.getCharEncoding());
response.setContentType(dsrouting.getContentType());
DSSession dsSession = (DSSession)request.getAttribute("DSSession");
DSServer dsServer =  dsSession.getServer();
DSServletCredentialMgr credMgr = DSServletCredentialMgr.getServletCredentialMgr(dsServer);
DSCredential cred = credMgr.getRequestCredential (request);
if(cred == null)
    System.out.println("routing_email.jsp RequestCredential is null");
else
    System.out.println("routing_email.jsp RequestCredential = " + cred.getLoginPrincipalHandle());
DSLoginPrincipal user = dsSession.getLoginPrincipal();
System.out.println("routing_email.jsp, LoginPrincipal() = " + user);

//get and forward request parameters routingSlipRequestID and workFlowJobName
String url = request.getParameter("url");
String workFlowJobName = request.getParameter("workFlowJobName");
String routingSlipRequestID = request.getParameter("routingSlipRequestID");
//for report only:
String reportType = request.getParameter("reportType");
String notifyID = request.getParameter("notifyID");
String aboutRecipient = request.getParameter("aboutRecipient");
String document = request.getParameter("document"); //AR7481+

//reopened AR9015+:
boolean showLoginPage = true; //only if already login with correct user, showLoginPage = false
try{
    //DSLoginPrincipal user = dsSession.getLoginPrincipal();
    if(user != null && !user.isGuestUser()){
        String handle = user.getHandle().toExternalForm();
        System.out.println("routing_email.jsp login user = " + handle);
        if(url == null){
            out.println("<br>Missing parameter url!<br>");
            return;
        }else if(url.startsWith("report_base.jsp")){//report, use workFlowJobName
            String workFlowOwner = dsrouting.getWorkFlowOwner(Integer.parseInt(workFlowJobName));
            System.out.println("routing_email.jsp workFlowOwner = " + workFlowOwner);
            if(handle.equals(workFlowOwner)) showLoginPage = false;
        }else{//request, use routingSlipRequestID
            String taskRecipient = dsrouting.getTaskRecipient(Integer.parseInt(routingSlipRequestID));
            System.out.println("routing_email.jsp taskRecipient = " + taskRecipient);
            if(handle.equals(taskRecipient))
                showLoginPage = false;
        }
    }
}catch(Exception e) { System.out.println("routing_email.jsp: "+ e); }
//reopened AR9015+

System.out.println("routing_email.jsp, showLoginPage = "+ showLoginPage);

if(showLoginPage){ //reopened AR9015-: cred == null
  //System.out.println("routing_email.jsp, dsSession.getLoginPrincipal() = "+ dsSession.getLoginPrincipal());
  //show login form:
  %>
  <form name="fm" method="POST" action="../RoutingLogin">
  <input type=hidden name="url" value="<%=url%>">
  <input type=hidden name="workFlowJobName" value="<%=workFlowJobName%>">  
  <%if(routingSlipRequestID != null){%>
  <input type=hidden name="routingSlipRequestID" value="<%=routingSlipRequestID%>">
  <%}
  if(reportType != null){%>
  <input type=hidden name="reportType" value="<%=reportType%>">
  <%}
  if(notifyID != null){%>
  <input type=hidden name="notifyID" value="<%=notifyID%>">
  <%}
  if(aboutRecipient != null){%>
  <input type=hidden name="aboutRecipient" value="<%=aboutRecipient%>">
  <%}
  if(document != null){%>
  <input type=hidden name="document" value="<%=document%>">
  <%}
  %>
  <script language="javascript">
  self.document.forms[0].submit();
  </script>  
<%
}else{ //already login
  //out.println("cred = "+ cred +"<br>");
  //out.println("getLoginPrincipalHandle = "+ cred.getLoginPrincipalHandle() +"<br>");
  String fullurl = url + "?workFlowJobName=" + workFlowJobName;
  if(routingSlipRequestID != null) fullurl += "&routingSlipRequestID=" + routingSlipRequestID;
  if(reportType != null) fullurl += "&reportType=" + reportType;
  if(notifyID != null) fullurl += "&notifyID=" + notifyID;
  if(aboutRecipient != null) fullurl += "&aboutRecipient=" + aboutRecipient;
  if(document != null) fullurl += "&document=" + document; //AR7481+
  %>
  <meta http-equiv="refresh" content="0; Url=<%=fullurl%>"/>
<%}%>
</body>
</html>